package com.stormtales.notevault.network.sync;

import com.stormtales.notevault.network.auth.LoginRequest;
import com.stormtales.notevault.network.auth.LoginResponse;
import com.stormtales.notevault.network.sync.models.*;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;
import okhttp3.ResponseBody;
import retrofit2.Call;
import retrofit2.http.*;

import java.time.LocalDateTime;

public interface SongSyncAPI {

    @POST("/sync/songs/create")
    Call<BatchCreateResponse> syncCreatedSongs(@Body SongCreateBatchRequest songCreateBatchRequest);

    @POST("/sync/songs/modify")
    Call<SongModifyBatchResponse> syncModifiedSongs(@Body SongModifyBatchRequest songModifyBatchRequest);

    @POST("/sync/songs/delete")
    Call<BatchModifyResponse> syncDeletedSongs(@Body SongBatchDeleteRequest songBatchDeleteRequest);

    @Multipart
    @POST("/sync/songs/note_sheet/upload")
    Call<UploadResponse> uploadNoteSheet(@Part("serverID")RequestBody serverID, @Part("fileName") RequestBody fileName, @Part MultipartBody.Part image);

    @Multipart
    @POST("/sync/songs/note_sheet/update")
    Call<UploadResponse> updateNoteSheet(@Part("server_filename") RequestBody server_filename, @Part MultipartBody.Part image);

    @GET("/sync/songs/fetch")
    Call<FetchResponse> fetchRemoteModifiedSongs(@Query(value = "last_client_sync") String last_client_sync);

    @GET("/sync/songs/get")
    Call<SongModel> fetchRemotelyModifiedSongData(@Query(value = "songID") String songID);

    @GET("/sync/songs/get/notesheet/")
    Call<ResponseBody> downloadNotesheet(@Query("server_filename") String server_filename);
}
